void IO_Setup(){

  //Inicializa hardware
  pinMode(pin_X3, INPUT);
  pinMode(pin_X4, INPUT);

  //pinMode(SENSOR, INPUT_PULLUP);
  pinMode(pin_Y2, OUTPUT); 
  pinMode(pin_Y3, OUTPUT);
  pinMode(pin_Y4, OUTPUT);
  pinMode(pin_Y5, OUTPUT);
  pinMode(pin_Y6, OUTPUT);

  pinMode(ENTX_pin, OUTPUT);

  //incio da biblioteca HX711
  Sensor1.begin();
  Sensor1.setSamplesInUse(1);
  Sensor1.start(2000, false);
  Sensor1.setCalFactor(1);
}

void IO_Ctrl() {
   
      if (Sensor1.update()) {
        TMP_Raw = Sensor1.getData();
        if (TMP_Raw < 0x7FFFFF) {
        TMP_Raw = (TMP_Raw ^ 0x800000);  // flip the 24th bit
        TMP_Raw = ((0xFFFFFF - TMP_Raw) * -1);
      } else {
        TMP_Raw = (TMP_Raw ^ 0x800000);  // flip the 24th bit
      } 
      
      for (int j=0; j<(N_Leituras - 1); j++){
        AUX_Array_Temp[j] = AUX_Array_Temp[j + 1];
      }
      AUX_Array_Temp[N_Leituras - 1] = TMP_Raw;
      AUX_Soma_Temp = 0;
      for (int j=0; j<N_Leituras; j++){
        
        AUX_Soma_Temp += AUX_Array_Temp[j];
      }
      AUX_Analog_Temp = AUX_Soma_Temp / N_Leituras;

      AUX_mA_Temp = map(AUX_Analog_Temp, -1320, 1980, 437, 3868);
      if (AUX_mA_Temp < Tabela_TipoK[0][0]) {
        IHM_STA_Act_Temperatura = map(AUX_mA_Temp, Tabela_TipoK[0][0], Tabela_TipoK[1][0], Tabela_TipoK[0][1], Tabela_TipoK[1][1]);
        IHM_STA_Act_Temperatura = IHM_STA_Act_Temperatura + Temp_Offset;
      }else if (AUX_mA_Temp > Tabela_TipoK[25][0]) {
        IHM_STA_Act_Temperatura = map(AUX_mA_Temp, Tabela_TipoK[24][0], Tabela_TipoK[25][0], Tabela_TipoK[24][1], Tabela_TipoK[25][1]);
        IHM_STA_Act_Temperatura = IHM_STA_Act_Temperatura + Temp_Offset;
      }else {
        for(int i = 0; i < 25; i++) {
          if (AUX_mA_Temp > Tabela_TipoK[i][0]) {
            IHM_STA_Act_Temperatura = map(AUX_mA_Temp, Tabela_TipoK[i][0], Tabela_TipoK[i+1][0], Tabela_TipoK[i][1], Tabela_TipoK[i+1][1]);
            IHM_STA_Act_Temperatura = IHM_STA_Act_Temperatura + Temp_Offset;
            break;
          }
        }
      }
    }

    if(IHM_STA_Act_Temperatura > IHM_PAR_Set_Temperatura + IHM_Config_Histerese){
      OUT_Resf = 1;
    }else if(IHM_STA_Act_Temperatura < IHM_PAR_Set_Temperatura){
      OUT_Resf = 0; 
    }

    //Acionamento das saídas
    digitalWrite(pin_Y3, OUT_Resf);
}
