#include <HX711_ADC.h>

#define SENSOR  13

//Definição dos pinos do controlador OPS012
//Saidas digiais
#define pin_Y2 12
#define pin_Y3 27
#define pin_Y4 26
#define pin_Y5 25
#define pin_Y6 33

//Entradas digitais
#define pin_X3 39
#define pin_X4 36

#define ENTX_pin 2

//Entradas de temperatura
const int Temp_DOUT_PIN1 = 18;
const int Temp_SCK_PIN1 = 5;

//Construtor da biblioteca de leitura de temperatura/carga
HX711_ADC Sensor1(Temp_DOUT_PIN1, Temp_SCK_PIN1);

//variaveis fluxo
long currentMillis = 0;
long previousMillis = 0;
int interval = 1000;
float calibrationFactor = 90;
volatile byte pulseCount;
byte pulse1Sec = 0;
float flowRate;
unsigned int flowMilliLitres;
unsigned int totalMilliLitres;

//Definição das variáveis de controle
int OUT_Resf = 1;

int16_t IHM_Config_Temp;
int16_t IHM_Config_Histerese;
int16_t IHM_STA_Act_Temperatura;
int16_t IHM_PAR_Set_Temperatura;

int16_t Temp_Offset;

//Variáveis para filtro das leituras de temperatura
#define N_Leituras 50
long AUX_Leitura_Temp;
long AUX_Array_Temp[N_Leituras];
long AUX_Soma_Temp;
long AUX_Analog_Temp;
long AUX_mA_Temp;
long TMP_Raw = 0;
